#include <stdio.h>

int main() {
  int a[1000];
  int b[1000];
  int c[1000];
  int d[1000];
  int i;
  int n;

  printf("ex1: Beispiel fuer Loop unrolling und Loop fusing.\n");
  printf("     Das Programm tut eigentlich nichts.\n");
  printf("     (c) N. Schmeisser, FVTK, FZ Rossendorf, 1996\n");

  n=5;

  // "Aufklappen" der Schleife in eine Folge von Anweisungen
  // Damit folgt Einsparung des M.Codes fuer die Schleife

  #pragma _CNX unroll
  for (i=0;i<n;i++) {
    a[i]=0;
    b[i]=0;
  }

  // Zusammenfuehren der beiden Schleifen
  // Damit Einsparung des M.Code Overheads fuer die zweite Schleife
  // Die Anweisung "#pragma _CNX prefer_fuse" wird allerdings durch
  // den Compiler mit der Meldung
  // cc: Warning on line 30 of ex1.c: 'prefer_fuse' is not a DIRECTIVE.
  // zurueckgewiesen. Man verwende die Option -fl um ein Loop-Fusing
  // zu erreichen (-nfl ersetzen).

  #pragma _CNX prefer_fuse
  for (i=0;i<n;i++) {
    a[i]=i;
  }

  #pragma _CNX prefer_fuse
  for (i=0;i<n;i++) {
    b[i]=i*10;
  }

  return 0;
}
