#include <stdio.h>
#include <spp_prog_model.h>

int main() {
  int i,n;

  printf("ex2: Schleifenparallelisierung und Thread-Konzept.\n");
  printf("     Eine Schleife mit n Iterationen wird parallelisiert.\n");
  printf("     Man versuche zwei Varianten: \n");
  printf("      1. Neuuebersetzung und Lauf mit Anzahl>8\n");
  printf("      2. Nach der Uebersetzung Aufruf von:\n");
  printf("         'mpa -m -min <anzahl> -max <anzahl> ex2'.\n");
  printf("     (c) N. Schmeisser, FVTK, FZ Rossendorf, 1996\n");

  printf("Anzahl Iterationen:");
  scanf("%d",&n);

  printf("  Anzahl hypernodes: %d\n",num_nodes());
  printf("     Anzahl Threads: %d\n",num_threads());

  // Weist den Compiler an, Thread-orientiert zu parallelisieren
  // Alternativ dazu ist die Parallelisierung bzgl. von Hypernodes moeglich

  #pragma _CNX loop_parallel(ivar=i,threads)
  for (i=0;i<n;i++) {
    printf("Hallo von Iteration #%d, auf Thread %d.\n",i,my_thread());
  }

  return 0;
}
